#include "lfs_threads.h"

#include <linux/aquosa/qos_debug.h>

pid_t threads[MAX_THREADS];
int num_threads = 0;

int get_threads(pid_t pid, pid_t *threads, int max_num_threads) {
	char cmd[80];
	int num = 0;
	sprintf(cmd, "/bin/ls /proc/%d/task", pid);
	FILE *f = popen(cmd, "r");

	qos_chk_do(f != NULL, return 0);

	while (num < max_num_threads && ! feof(f)) {
		unsigned int tid;
		if (fscanf(f, "%u", &tid) == 1) {
			threads[num++] = tid;
			qos_log_debug("Found thread: %d", tid);
		}
	}
	pclose(f);
	return num;
}

int add_threads(pid_t pid) {
	int added_threads = get_threads(pid, threads + num_threads, MAX_THREADS - num_threads);
	num_threads += added_threads;
	return added_threads;
}

int add_thread(pid_t pid) {
	if (num_threads == MAX_THREADS)
		return 0;
	threads[num_threads++] = pid;
	return 1;
}
