#include <sys/types.h>
#include <sched.h>

#define MAX_THREADS 16
extern pid_t threads[MAX_THREADS];
extern int num_threads;

/** Finds child threads of pid, adding them to the threads[] array, up
 ** to a maximum number of max_num_threads.
 **
 ** @return The number of added threads (children of pid)
 **/
int add_threads(pid_t pid);

/** Add only the specified thread, without children
 **
 ** @return 1 if the thread was added, 0 in case of error
 **/
int add_thread(pid_t pid);

int get_threads(pid_t pid, pid_t *threads, int max_num_threads);
